using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Rendering;

public class CityGenerator : MonoBehaviour
{
    public GameObject CityPrefab;
    GameObject director;
    TSPsolver tspsolver;

    private float time = 0.0f;
    void Start()
    {
        this.director = GameObject.Find("TSPsolver");
        this.tspsolver = this.director.GetComponent<TSPsolver>();
    }

    void FixedUpdate()
    {
        // 単押しと長押しを区別する
        // 現時点では必要ないが長押しでのアクションを実装するときに必要
        if(Input.GetMouseButtonDown(1))
        {
            time = 0.0f;
        }
        if(Input.GetMouseButton(1))
        {
            time += Time.deltaTime;
        }
        if(Input.GetMouseButtonUp(1))
        {
            if(time < 0.5f)
            {
                Vector3 pos = Camera.main.ScreenToWorldPoint(Input.mousePosition);
                pos.z = 0;
                List<GameObject> CitiesList = tspsolver.CitiesList;
                for(int i = 0;i < CitiesList.Count;i++)
                {   
                    float dist = Vector3.Distance(pos,CitiesList[i].transform.position);
                    if(dist < 0.1f)return;
                }
                GameObject city = Instantiate(CityPrefab) as GameObject;
                city.transform.position = pos;
                tspsolver.AddCity(city);
            }
        }
    }
}
